'--------------------------------------------------------------------------
'File Name:	 MS_Hf_Install.vbs
'Author:	   Jigar Desai
'Purpose:	   To use common MS Hotfixes install file, for both CD and RSD
'Usage:     [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label LogFileName
'           For Example, CScript MS_Hf_Install.vbs RSD April07_HF  C:\temp\MIApps_6.5.9.12.log 
'                    or  CScript MS_Hf_Install.vbs CD ALL  C:\temp\MIApps_6.5.9.13.log
'--------------------------------------------------------------------------

dim oShell, filesys
dim cmd, return_code, args, num
dim Deployment, Patch_label, LOGName 

set args = WScript.Arguments
num = args.Count

if num = 0 then
   WScript.Echo "Usage: [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs RSD ALL C:\temp\MI_MI016_07_R.log"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs CD ALL C:\temp\MI_MI016_07_R.log"
   WScript.Quit 1
end if

Deployment = args(0)
Patch_label = args(1)
LOGName = args(2)

Set oShell = CreateObject("WScript.Shell")
Set filesys = CreateObject("Scripting.FileSystemObject")

If filesys.FileExists(LOGName) Then
	Set logfile = filesys.OpenTextFile(LOGName, 8)
else
	Set logfile = filesys.CreateTextFile(LOGName, True)
end if

logfile.WriteLine(vbNewLine)
logfile.WriteLine(vbNewLine)
logfile.WriteLine(Date() & vbTab & Time())


if Deployment = "CD" OR (Deployment = "RSD" And Patch_label = "September08_HF") then
  if  Deployment = "RSD" then
    logfile.WriteLine("This Microsoft Hotfix installation for " & Patch_label &" is done through Remote Software Distribution. Checking for Previous month's hotfixes on the system")
    logfile.WriteLine("Checking HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\HotFix\KB950974\Installed")
    If RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" _
         & "\HotFix\KB950974\Installed") <> "1" Then
      logfile.WriteLine("This system does not have required MS hotfixes to install" & Patch_label)
      logfile.WriteLine("MS Hotfix installation will now abort.")
      Wscript.quit("1")
    End if
  End if
  logfile.WriteLine("Installing MS Hotfixes for September 2008")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB938464")
  cmd = "MS08-052.WindowsXP-KB938464-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938464 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938464 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB938464")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select


  
  logfile.WriteLine("Finish installing MS Hotfixes for September 2008")
end if



logfile.WriteLine("MS HotFix installation successfully finished on " & Date() & vbTab & Time())

Set oShell = Nothing
Set filesys = Nothing
Set logfile = Nothing
set args = Nothing
Wscript.quit("0")

Function RegRead(ByVal sRegValue)
      Set oShell = CreateObject("WScript.Shell")
      On Error Resume Next
      RegRead = oShell.RegRead(sRegValue)
      logfile.WriteLine(vbTab & vbTab & "Installed Value of " & sRegValue & " is: " & RegRead)
      ' If the value does not exist, error is raised
      If Err Then
        RegRead = ""
        Err.clear
      End If
      ' If a value is present but uninitialized the RegRead method
      ' returns the input value in Win2k.
      If VarType(RegRead) < vbArray Then
        If RegRead = sRegValue Then
          RegRead = ""
        End If
      End If
      On Error Goto 0
End Function
